import QtQuick 1.0
import com.meego 1.0

Page {
    
  	    
// orientationLock: PageOrientation.LockLandscape
//     orientationLock: PageOrientation.LockPortrait
    
//*******************************************************
    
    
    id: mainPage
    tools: toolbar

    anchors.margins: 10


    Column {
	id: col
	spacing: 10
	width: parent.width  
	height: parent.height
	  
        Flickable {
	    id: flickable
	    contentWidth: bibleText.width
	    contentHeight: bibleText.height
	    width: parent.width  
	    height: parent.height
	    flickableDirection: Flickable.VerticalFlick
	    clip: true

	    TextEdit{
		id: bibleText
		wrapMode: TextEdit.Wrap
		width: col.width
		readOnly:true		
// 		onLinkActivated:{
// 		    console.log("link clicked")
// 		}
            }            
	}
	
	
	Image {
	    id: end_fullscreen
	    anchors.bottom: flickable.bottom
	    anchors.right: flickable.right
	    source: "../images/end_fullscreen.png"
	    visible: false
	    
	    MouseArea {
		anchors.fill: parent
		onClicked: { 
// 		    console.log("quit full screen")
		    appWindow.showStatusBar = true
		    appWindow.showToolBar = true
		    end_fullscreen.visible = false
		}
	    }
	}
	
	
	ScrollDecorator { 
	    flickableItem: flickable 	  
	}
 

    }



//*******************************************************



    ToolBarLayout {
	id: toolbar
	
	ToolButtonRow { 
	  
	    ToolIcon {
                id: bBook
                platformIconId: "icon-m-toolbar-directory"
                onClicked: {
		      dialogBooks.open();
		  }
	    }
                
	    ToolIcon {
                id: bChapter
                platformIconId: "icon-m-toolbar-grid"
                onClicked: {
		      dialogChapters.open();
		  }
	    }
                
	    ToolIcon {
                id: bLast
                width: 48
                platformIconId: "toolbar-previous"
                onClicked: {
		    var chapter = dialogChapters.model.get(dialogChapters.selectedIndex).name
		    chapter = chapter*1 - 1
// 		    console.log(chapter) 
		    if(chapter > 0){
			qml_to_python.setChapter(chapter)
			dialogChapters.selectedIndex = dialogChapters.selectedIndex - 1
		    }
                }
	    }
                
	    ToolIcon {
                id: bNext
                width: 48
                platformIconId: "toolbar-next"
                onClicked: {
		    var chapter = dialogChapters.model.get(dialogChapters.selectedIndex).name
		    chapter = chapter*1 + 1
// 		    console.log(chapter) 
		    if(chapter <= chaptersList.count){
			qml_to_python.setChapter(chapter)			
			dialogChapters.selectedIndex = dialogChapters.selectedIndex + 1
		    }
                }
	    }     
	    
/*	    ToolIcon {
		iconId: "icon-m-toolbar-attachment" ;
		onClicked: DialogBookmarks.open();
	    }	*/    
                
	    ToolIcon {
                id: bFullscreen
                width: 48
                platformIconId: "toolbar-start-fullscreen"
//                 platformIconId: "icon-m-toolbar-application"
                onClicked: {
		    appWindow.showStatusBar = false
		    appWindow.showToolBar = false
		    end_fullscreen.visible = true
                }
	    }

                
	} 
	    
	ToolIcon {
	    iconId: "toolbar-view-menu" ;
	    onClicked: menuMain.open();
	}
    }
    
    
    
    

//*******************************************************
    
    
    SelectionDialog {
        id: dialogBooks
        titleText: "Select book"

        model: ListModel {
	    id: bookList
        }
        onAccepted: { 
	    var book = dialogBooks.model.get(dialogBooks.selectedIndex).value
// 	    console.log(book) 
	    dialogChapters.selectedIndex = 0
	    qml_to_python.setBook(book)
	}
    }
        
        
        
    function fillListOfBooks(books){
// 	console.log("fillListOfBooks", books, books.length)
	bookList.clear()
	for (var i = 0; i < books.length; i++) {
// 	    console.log(i)
// 	    console.log(i, books[i][0], books[i][1])
            bookList.append({"name": books[i][0], "value": books[i][1]});
        }
// 	dialogBooks.selectedIndex = selectedBook-1;
    }
    
    
    
    function bookListSetSelected(selectedBook){
// 	console.log("bookListSetSelected", bookList.count, selectedBook)
	for (var i = 0; i < bookList.count; i++) {
// 	  console.log(i, bookList.get(i).value)
            if(bookList.get(i).value == selectedBook){
		dialogBooks.selectedIndex = i
		return
	    }
        }
    }
    

    
//*******************************************************
    
        
    SelectionDialog {
        id: dialogChapters
        titleText: "Select chapter"

        model: ListModel {
	    id: chaptersList
	 }

        onAccepted: { 
	    var chapter = dialogChapters.model.get(dialogChapters.selectedIndex).name
// 	    console.log(chapter) 
// 	    qml_to_python.setChapter(chapter)
	    
	    if(chapter == ""){
		console.log("selected empty chapter entry, revert to previous one")
		//ToDo: set selected index back to previous one
	    }
	    else {
	    qml_to_python.setChapter(chapter)
	    }
	}
    }

    
    
    function fillListOfChapters(chapters){
	chaptersList.clear()
	for (var i = 1; i <= chapters; i++) {
            chaptersList.append({"name" : i+""});
        }
	console.log("chaptersList")
	if(chapters < 12){ //Bug fix (list is not shown on the device when there are less than 12 entries): 
	    for (var i = chapters; i < 12; i++) chaptersList.append({"name" : ""});
	}
    }
    
    
    function chapterListSetSelected(selectedChapter){
      	dialogChapters.selectedIndex = selectedChapter-1;
// 	console.log("chapterListSetSelected", selectedChapter, chaptersList.count)
	
// 	if(selectedChapter == 1) bLast.enabled = false
// 	else if(chaptersList.count == 1) bLast.enabled = false
// 	else bLast.enabled = true
// 	  
// 	if(selectedChapter == chaptersList.count) bNext.enabled = false
// 	else if(chaptersList.count == 1) bNext.enabled = false
// 	else bNext.enabled = true
    }
    
    
    
//*******************************************************
    
    function setBibleText(text){
	bibleText.text = text
	flickable.contentY = 0
    }
   
}
