import QtQuick 1.0
import com.meego 1.0

import "." as MyComponents


PageStackWindow {
    id: appWindow

    function loadParametersfromPython(translation, secondTranslation, selectedBook, chapters, selectedChapter, bookLanguage, fontSize){
// 	console.log("QMLloadParametersfromPython")
	for (var i = 0; i < translationsList.count; i++) {
            if(translationsList.get(i).name == translation){
		dialogTranslations.selectedIndex = i	 		
// 		break
	    }
            if(translationsList.get(i).name == secondTranslation){
		dialogTranslations2.selectedIndex = i	 		
// 		break
	    }
        }


	mainPage.bookListSetSelected(selectedBook)
	mainPage.fillListOfChapters(chapters)
	mainPage.chapterListSetSelected(selectedChapter)
// 	mainPage.bookLanguageSetSelected(bookLanguage)
	
	
// 	for (var i = 0; i < bookLanguagesList.count; i++) {
// 	    console.log(bookLanguagesList.get(i).value, bookLanguage)
//             if(bookLanguagesList.get(i).value == bookLanguage){
		dialogBookLanguages.selectedIndex = bookLanguage	 		
// 		break
// 	    }
//         }
        
        dialogFontSize.selectedIndex = fontSize
    }
    
    
    
    
    function loadTextfromPython(text){
	mainPage.setBibleText(text)	
    }
    
    
    
    
    function fillListOfBooks(books){      
	mainPage.fillListOfBooks(books)
    }
    
    
    function themeInverted(inverted){	
	theme.inverted = inverted;
    }
    

    
    
    function fillListOfInstalledTranslations(translations){
	console.log("fillListOfInstalledTranslations")
	translationPage.fillListOfInstalledTranslations(translations)	
    }
    
    
    function fillListOfRemoteTranslations(translations){
	translationPage.fillListOfRemoteTranslations(translations)	
    }
    
    
    
    function setProgress(x){
// 	console.log(x)
	translationPage.setProgress(x)
    }
        
//     function setDownloadComplete(){
// 	console.log("setDownloadComplete")
// 	translationPage.setDownloadComplete()
//     }
    
//*******************************************************
    
    initialPage: mainPage
    MainPage{id: mainPage}


    Menu {
        id: menuMain
        MenuLayout {

            MenuItem {
                text: "About MiniBible"
                onClicked: { about.open(); }
            }
//             MenuItem {
//                 text: "About translation(s)"
//                 onClicked: { aboutTanslation.open(); }
//             }
            MenuItem {
                text: "Help"
                onClicked: { help.open(); }
            }
            MenuItem {
                text: "Select translation"
                onClicked: { dialogTranslations.open(); }
            }
            MenuItem {
                text: "Select 2nd translation"
                onClicked: { dialogTranslations2.open(); }
            }
            MenuItem {
                text: "Settings"
                onClicked: { menuSettings.open(); }
            }
        }
    }
    
      Menu {
        id: menuSettings
        MenuLayout {
       
            MenuItem {
                text: "Add/Remove translations"
                onClicked: { 
		  qml_to_python.fillListOfInstalledTranslations()
		  pageStack.push(translationPage) 		  
		}
            }
            MenuItem {
                text: "Toggle split screen"
                onClicked: { qml_to_python.toggleSplitScreen(); }
            }
            MenuItem {
                text: "Inverse theme"
                onClicked: { qml_to_python.themeInverted(); }
            }
            MenuItem {
                text: "Select language of books"
                onClicked: { dialogBookLanguages.open(); }
            }
            MenuItem {
                text: "Set font size"
                onClicked: { dialogFontSize.open(); }
            }
        }
    }



//*******************************************************

    SelectionDialog {
        id: dialogTranslations
        titleText: "Select translation"

        model: ListModel {
	    id: translationsList
	}


        onAccepted: { 
	    var translation = dialogTranslations.model.get(dialogTranslations.selectedIndex).name
// 	    console.log("translation:", translation, "-") 
	    if(translation == ""){
		console.log("selected empty translation entry, revert to previous one")
		//ToDo: set selected index back to previous one
	    }
	    else {
		qml_to_python.setTranslation(translation)
	    }
	}
    }
        
    


    SelectionDialog {
        id: dialogTranslations2
        titleText: "Select 2nd translation"

        model: ListModel {
	    id: translationsList2
	}


        onAccepted: { 
	    var translation2 = dialogTranslations2.model.get(dialogTranslations2.selectedIndex).name
	    if(translation2 == ""){
		console.log("selected empty translation entry, revert to previous one")
		//ToDo: set selected index back to previous one
	    }
	    else {
		qml_to_python.setTranslation2(translation2)
	    }
	}
    }
    
    
    function loadListOfTranslationsFromPython(translations, selectedTranslation, selectedTranslation2){
	translationsList.clear()
	var index = -1
	var index2 = -1
	for (var i = 0; i < translations.length; i++) {
            translationsList.append({"name" : translations[i]});
            translationsList2.append({"name" : translations[i]});
	    if(translations[i] == selectedTranslation) index=i
	    if(translations[i] == selectedTranslation2) index2=i
        }
        
        if(translations.length < 12){ //Bug fix (list is not shown on the device when there are less than 12 entries): 
	    for (var i = translations.length; i < 12; i++) translationsList.append({"name" : ""});
	    for (var i = translations.length; i < 12; i++) translationsList2.append({"name" : ""});
	}

	dialogTranslations.selectedIndex = index
	dialogTranslations2.selectedIndex = index2
    }

    
    
    
    
//*******************************************************
 

    SelectionDialog {
        id: dialogBookLanguages
        titleText: "Select language of books"

        model: ListModel {
	    id: bookLanguagesList
	    ListElement { name: "English" }
	    ListElement { name: "Deutsch" }
	    ListElement { name: "Svenska" }
	}

        onAccepted: { 
		qml_to_python.setBookLanguage(dialogBookLanguages.selectedIndex)
	}
    }    
    
    
//*******************************************************
 

    SelectionDialog {
        id: dialogFontSize
        titleText: "Select language of books"

        model: ListModel {
	    id: fontSizeList
	    ListElement { name: "Big"}
	    ListElement { name: "Bigger"}
	    ListElement { name: "Normal"}
	    ListElement { name: "Smaller"}
	    ListElement { name: "Small"}
	}

        onAccepted: { 
// 	    var fontSize = dialogFontSize.model.get(dialogFontSize.selectedIndex).value
	    var fontSize = dialogFontSize.selectedIndex
	    qml_to_python.setFontSize(fontSize)
// 	    }
	}
    }
    


//*******************************************************


    QueryDialog {
        id: about
        icon: "../images/minibible.png"
        titleText: "About MiniBible"
        message: "MiniBible is a simple bible reader. It can show all translations packed in the SWORD project format. "+
		 "It works in landscape as well as in portrait mode and can show up to 2 translations in a split view for comparison.\n\n"+
		 "Version: " + qml_to_python.getVersion() + "\n" +
                 "License: GPL\n"+
		 "Copyright 2011 by George Ruinelli\n"+
                 "Contact: george@ruinelli.ch\n"+
                 "URL: www.ruinelli.ch\n\n"+
		 "For more information about the SWORD project, please see www.crosswire.org/sword\n\n" +
		 "Logo Copyright by www.christart.com"
    }

    
    
//*******************************************************



    QueryDialog {
        id: help
        icon: "../images/minibible.png"
        titleText: "MiniBible Help"
        message: "This program is a bible reader. Select a valid bible translation from the menu. If the list is empty, you haven't yet downloaded a bible module. To do so, please use the Translation manager (Settings > Add/Remove Translations)\n\n" + 
	"You can use a split screen to show 2 translations beside each other for comparison.\n\n" +
	"The names of the books (Genesis, Exodus,..) can be set separately. This way you can read i.e. an English translations but the book names are still shown in German."
    } 
    


//*******************************************************

    QueryDialog {
        id: aboutTanslation
        titleText: "About the translation(s)"
        message: "Not yet implemented"
    }
    
    
    function fillAboutTranslation(message){
	aboutTanslation.message = message
    }
    



//*******************************************************


    MyComponents.TranslationPage {
        id: translationPage
    }
    
    
    
}